///// [ LICENSE ] //////////////////////////////////////////////////////////////
//
// (c) 2009 Dynamite Data / Tom Corelis
// 
// Unless explicitly stated otherwise, the programming code in this file is
// licensed to you pursuant the terms described in codelicense.txt.
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Respect the global namespace!
//
// Normal code is embedded in our module object.
////////////////////////////////////////////////////////////////////////////////
//Components.utils.import("resource://ddfirefox/modules/namespace-fix.jsm");
if(!com) var com = new Object();
if(!com.dynamitedata) com.dynamitedata = {};
if(!com.dynamitedata.ddfGlobals) com.dynamitedata.ddfGlobals = {};

Components.utils.import("resource://ddfirefox/modules/globals.jsm", com.dynamitedata.ddfGlobals);

com.dynamitedata.ddfDetails = function() {
    
    // CONSTANTS
    var DEALS_LISTBOX_NAME = "ddLstDealsRich";
    
    // global variables
    var productURLCur;
    var ddLstDeals = document.getElementById(DEALS_LISTBOX_NAME);
    var ddFrmDetailsHandle;    
    
    //currency format and localization
    // localized string bundle
    //var strBundle = document.getElementById("strBundle");
    //var strSet = document.getElementById("strBundleOverlay");
    ////////////////////////////////////////////////////////////////////////////////
    //  event handlers
    ////////////////////////////////////////////////////////////////////////////////
    var detailsEvents = {
        
        onDblClickDetailsList: function() {
            var ddLstDeals = document.getElementById(DEALS_LISTBOX_NAME);
            var selected = ddLstDeals.selectedIndex;
            openSelectedMerchantURL(selected);
        },
    
        onDblClickLogo: function() {
            ddFrmDetailsHandle.hidePopup();
            com.dynamitedata.ddfUtil.openDynamiteDataURL("main");
        },
    
        onClickCloseButton: function() {
            ddFrmDetailsHandle.hidePopup();
        },
        
        onClickBetaButton: function() {
            ddFrmDetailsHandle.hidePopup();
            com.dynamitedata.ddfUtil.openDynamiteDataURL("beta");
            
        },
        
        onClickReportaProblem: function() {
            ddFrmDetailsHandle.hidePopup();
            document.getElementById("ddFrmMsgPanel").hidePopup();
            openDialog("chrome://ddfirefox/content/options.xul", "window", "chrome,resizable=yes,centerscreen,modal", 0, gBrowser.currentURI.spec);
            //ref.fillInValues("optDealPriceIncorrect", gBrowser.currentURI.spec);
        },
        
        onStartup: function() {

            //register event listeners
            document.getElementById("ddBoxLogoBgDetails")
                .addEventListener("dblclick", detailsEvents.onDblClickLogo, false);
            document.getElementById("detDdBtnCloseDetails")
                .addEventListener("click", detailsEvents.onClickCloseButton, false);
            //document.getElementById("detDdBtnBeta")
            //    .addEventListener("click", detailsEvents.onClickBetaButton, false);
            document.getElementById("rlFirstDeal")
                .addEventListener("click", detailsEvents.onDblClickDetailsList, false);
            document.getElementById("rlSecondDeal")
                .addEventListener("click", detailsEvents.onDblClickDetailsList, false);
            document.getElementById("rlThirdDeal")
                .addEventListener("click", detailsEvents.onDblClickDetailsList, false);
            document.getElementById("rlFooter")
                .addEventListener("click", detailsEvents.onClickReportaProblem, false);
            document.getElementById("rlMsgFooter")
                .addEventListener("click", detailsEvents.onClickReportaProblem, false);
            document.getElementById("ddDetailsListMessage")
                .addEventListener("click", detailsEvents.onClickReportaProblem, false);
            document.getElementById("lblGotAProblem")
                .addEventListener("click", detailsEvents.onClickReportaProblem, false);
            
                
            //var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
            //var current = gExtensionManager.getItemForID("ddfirefox@dynamitedata").version;
            document.getElementById("lblVersion").value = com.dynamitedata.ddfGlobals.globals.version;
            document.getElementById("lblMsgVersion").value = com.dynamitedata.ddfGlobals.globals.version;
        
            
            //set window handle for other events
            ddFrmDetailsHandle = document.getElementById("ddFrmDetailsNewPanel");
            
            
        }
    
    }
    
    ////////////////////////////////////////////////////////////////////////////////
    // stuff for manipulating the list boxes
    ////////////////////////////////////////////////////////////////////////////////
    
    com.dynamitedata.ddfDetails.externPopulateDealsList = function(t) {
        populateDealsList(t);
    }
    
    function populateDealsList(t) {
        
        var strRebate = "*After {REBATE} rebate";
        var strRebateAppend = /*" AR"*/"*";
        var strRebateNoAppend = "";
        var strShipping = "Ships for {AMT}";
        var strShippingCheck= "Check merchant for shipping";
        var strShippingFree = "Free shipping";
        var strShippingEstimate = "Estimated shipping of {AMT}";
        
        //show/hide the beta button
        document.getElementById("detDdBtnBeta").hidden = !com.dynamitedata.ddfGlobals.globals.beta;
        
        setProductURLCur(t);
        com.dynamitedata.ddfGlobals.dprint("Details Window: Populating...");
        
        // get the tracking gif
        document.getElementById("detDdTrackingGif").src = productURLCur.trackingURL;
        com.dynamitedata.ddfGlobals.dprint("tracking gif set to " + document.getElementById("detDdTrackingGif").src, 2);
        
        // show the merchant warning thingy if applicable
        if (com.dynamitedata.ddfGlobals.LIST_COUNTRIES_NOEXPANSION.indexOf(productURLCur.territory) == -1) {
            document.getElementById("rlMerchantWarning").setAttribute("hidden", "false");
        }
        
        // set territory display if applicable
        if (productURLCur.territory.toLowerCase() == com.dynamitedata.ddfGlobals.ddGetStringPref("overrideCountry").toLowerCase()) {
            document.getElementById("lblCountryOverride").value = "Results locked to " + productURLCur.territory.toUpperCase();
        } else {
            document.getElementById("lblCountryOverride").value = "";
        }
        
        // reset ... not sure if this is necessary? been a while
        document.getElementById("rlMerchantWarning").hidden = true;

        if (productURLCur.message) {
			document.getElementById("lblFreeText").childNodes[0].nodeValue = productURLCur.message;
			document.getElementById("rlMerchantWarning").hidden = false;
		}
      
        // show lowest price/exclusive merchant notices
        //if (productURLCur.originHasBestPrice) {
            
        //    document.getElementById("lblFreeText").value = "The product page you are viewing has the best price!";
        //    document.getElementById("rlMerchantWarning").hidden = false;
            
            
        //}
        
        //if (productURLCur.exclusive) {
            
        //    document.getElementById("lblFreeText").value = "This is the only merchant that carries this item.";
        //    document.getElementById("rlMerchantWarning").hidden = false;
            
        //}
        
        var sBuf; // string formatting buffer
        // TODO: this implementation sucks
        for (i = 0; com.dynamitedata.ddfGlobals.PRODUCT_INFO_MAXRESULTS > i; i++) {
            if (i == 0) { // first, featured item
                var firstMerchName = document.getElementById("lblFirstMerchantName");
                var firstMerchPic = document.getElementById("imgFirstMerchantPicture");
                var firstMerchPrice = document.getElementById("lblFirstMerchantPrice");
    
                var firstMerchRebate = document.getElementById("lblFirstMerchantRebate");
                var firstMerchShipping = document.getElementById("lblFirstMerchantShipping");
    
                if (productURLCur.deals[i].rebate) {
                    var appended = strRebateAppend;
                } else {
                    var appended = strRebateNoAppend;
                }
    
                firstMerchName.value = productURLCur.deals[i].retailer;
                firstMerchPrice.value = com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].finalprice, productURLCur.currencyUnit) + appended;
    
                if (productURLCur.deals[i].rebate) {
                    firstMerchRebate.hidden = false;
                    firstMerchRebate.value = com.dynamitedata.ddfGlobals.supplant(strRebate, {
                        REBATE: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].rebate, productURLCur.currencyUnit)
                    });
                } else {
                    firstMerchRebate.hidden = true;
                }
    
                if (productURLCur.deals[i].shipping > 0 && productURLCur.deals[i].estimate ) {
                    firstMerchShipping.hidden = false;
                    firstMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShippingEstimate, {
                        AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                    });
                } else if (productURLCur.deals[i].shipping > 0) {
                    firstMerchShipping.hidden = false;
                    firstMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShipping, {
                        AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                    });
                } else if (productURLCur.deals[i].shipping == 0) {
                    firstMerchShipping.hidden = false;
                    firstMerchShipping.value = strShippingFree;
                } else {
                    firstMerchShipping.hidden = false;
                    firstMerchShipping.value = strShippingCheck;
                }
    
                // set merchant logo -- com.dynamitedata.ddfGlobals.supplant() is JS' string formatting command
                var imageURL = com.dynamitedata.ddfGlobals.MERCHANT_IMAGE_URL;
                var imageURLReseller = {
                    RID: productURLCur.deals[i].retailerID
                };
                firstMerchPic.src = com.dynamitedata.ddfGlobals.supplant(imageURL, imageURLReseller);
                com.dynamitedata.ddfGlobals.dprint("merchant logo request: " + firstMerchPic.src, 2);
                firstMerchPic.addEventListener("load",
                function() {
                    firstMerchName.hidden = true;
                },
                false);
    
                document.getElementById("rlFirstDeal").dealURL = productURLCur.deals[i].url;
    
            } else if (i == 1) {
    
                if (productURLCur.deals[i]) {
    
                    document.getElementById("rlSecondDeal").hidden = false;
    
                    var secondMerchName = document.getElementById("lblSecondMerchantName");
                    var secondMerchPrice = document.getElementById("lblSecondMerchantPrice");
    
                    if (productURLCur.deals[i].rebate) {
                        var appended = strRebateAppend;
                    } else {
                        var appended = strRebateNoAppend;
                    }
    
                    var secondMerchRebate = document.getElementById("lblSecondMerchantRebate");
                    var secondMerchShipping = document.getElementById("lblSecondMerchantShipping");
                    
                    if (productURLCur.deals[i].rebate) {
                        secondMerchRebate.hidden = false;
                        secondMerchRebate.value = com.dynamitedata.ddfGlobals.supplant(strRebate, {
                            REBATE: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].rebate, productURLCur.currencyUnit)
                        });
                    } else {
                        secondMerchRebate.hidden = true;
                    }
    
                	if (productURLCur.deals[i].shipping > 0 && productURLCur.deals[i].estimate ) {
                    	secondMerchShipping.hidden = false;
                    	secondMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShippingEstimate, {
                    	    AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                    	});
	                } else if (productURLCur.deals[i].shipping > 0) {
                        secondMerchShipping.hidden = false;
                        secondMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShipping, {
                            AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                        });
                    } else if (productURLCur.deals[i].shipping == 0) {
                        secondMerchShipping.hidden = false;
                        secondMerchShipping.value = strShippingFree;
                    } else {
                        secondMerchShipping.hidden = false;
                        secondMerchShipping.value = strShippingCheck;
                    }
    
                    secondMerchName.value = productURLCur.deals[i].retailer;
                    secondMerchPrice.value = com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].finalprice, productURLCur.currencyUnit) + appended;
                    
                    document.getElementById("rlSecondDeal").dealURL = productURLCur.deals[i].url;
    
                } else {
                    document.getElementById("rlSecondDeal").hidden = true;
                }
    
            } else if (i == 2) {
    
                if (productURLCur.deals[i]) {
                    
                    document.getElementById("rlThirdDeal").hidden = false;
    
                    var thirdMerchName = document.getElementById("lblThirdMerchantName");
                    var thirdMerchPrice = document.getElementById("lblThirdMerchantPrice");
    
                    if (productURLCur.deals[i].rebate) {
                        var appended = strRebateAppend;
                    } else {
                        var appended = strRebateNoAppend;
                    }
    
                    var thirdMerchRebate = document.getElementById("lblThirdMerchantRebate");
                    var thirdMerchShipping = document.getElementById("lblThirdMerchantShipping");
                    if (productURLCur.deals[i].rebate) {
                        thirdMerchRebate.hidden = false;
                        thirdMerchRebate.value = com.dynamitedata.ddfGlobals.supplant(strRebate, {
                            REBATE: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].rebate, productURLCur.currencyUnit)
                        });
                    } else {
                        thirdMerchRebate.hidden = true;
                    }
    
                	if (productURLCur.deals[i].shipping > 0 && productURLCur.deals[i].estimate ) {
                    	thirdMerchShipping.hidden = false;
                    	thirdMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShippingEstimate, {
                    	    AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                    	});
                	} else if (productURLCur.deals[i].shipping > 0) {
                        thirdMerchShipping.hidden = false;
                        thirdMerchShipping.value = com.dynamitedata.ddfGlobals.supplant(strShipping, {
                            AMT: com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].shipping, productURLCur.currencyUnit)
                        });
                    } else if (productURLCur.deals[i].shipping == 0) {
                        thirdMerchShipping.hidden = false;
                        thirdMerchShipping.value = strShippingFree;
                    } else {
                        thirdMerchShipping.hidden = false;
                        thirdMerchShipping.value = strShippingCheck;
                    }
    
                    thirdMerchName.value = productURLCur.deals[i].retailer;
                    thirdMerchPrice.value = com.dynamitedata.ddfGlobals.getFormattedCurrency(productURLCur.deals[i].finalprice, productURLCur.currencyUnit) + appended;
                    
                    document.getElementById("rlThirdDeal").dealURL = productURLCur.deals[i].url;
                } else {
                    document.getElementById("rlThirdDeal").hidden = true;
                }
    
            }
        }
        
        com.dynamitedata.ddfGlobals.dprint(com.dynamitedata.ddfGlobals.supplant("Shipping should display as follows:\n{OH} {OV}\n{TH} {TV}\n{HH} {HV}", {
                OH: firstMerchShipping.hidden.toString(),
                OV: firstMerchShipping.value,
                TH: secondMerchShipping.hidden.toString(),
                TV: secondMerchShipping.value,
                HH: thirdMerchShipping.hidden.toString(),
                HV: thirdMerchShipping.value}), 2);
    
        lstDealsRich = document.getElementById("ddLstDealsRich");
        lstDealsRich.clearSelection();
    }
    
    ////////////////////////////////////////////////////////////////////////////////
    // url openers
    ////////////////////////////////////////////////////////////////////////////////
    function openSelectedMerchantURL(selected) {
        com.dynamitedata.ddfGlobals.dprint("Details Window: User wants to go to...");
        com.dynamitedata.ddfGlobals.dprint("^^ " + productURLCur.deals[selected].url);
        // open selected in URL
        window.getBrowser().selectedTab = window.getBrowser().addTab(productURLCur.deals[selected].url);
        detailsEvents.onClickCloseButton(); //close window
    }
    
    function openDynamiteDataURL(urlTableEntry) {
        window.getBrowser().selectedTab = window.getBrowser().addTab(com.dynamitedata.ddfGlobals.urlTable[urlTableEntry]);
    }
    
    ////////////////////////////////////////////////////////////////////////////////
    // getters and setters
    ////////////////////////////////////////////////////////////////////////////////
    function setProductURLCur(productURL) {
        productURLCur = new com.dynamitedata.ddfGlobals.CloneObject(productURL);
        com.dynamitedata.ddfGlobals.dprint("Details Window: setProductURLCur just set " + productURLCur.deals.length + " deals.")   
    }
    
    window.addEventListener("load", detailsEvents.onStartup, false);
    
}

com.dynamitedata.ddfDetails();
