///// [ LICENSE ] //////////////////////////////////////////////////////////////
//
// (c) 2009 Dynamite Data / Tom Corelis
// 
// Unless explicitly stated otherwise, the programming code in this file is
// licensed to you pursuant the terms described in codelicense.txt.
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Respect the global namespace!
//
// Normal code is embedded in our module object.
////////////////////////////////////////////////////////////////////////////////
//Components.utils.import("resource://ddfirefox/modules/namespace-fix.jsm");
if(!com) var com = new Object();
if(!com.dynamitedata) com.dynamitedata = {};
if(!com.dynamitedata.ddfGlobals) com.dynamitedata.ddfGlobals = {};

Components.utils.import("resource://ddfirefox/modules/globals.jsm", com.dynamitedata.ddfGlobals);

com.dynamitedata.ddfWelcome = function() {
	
	var cddfw = this;
	var dprint = com.dynamitedata.ddfGlobals.dprint;
	
	var messageEvents = {
		
		onDblClickLogo: function() {
			
			com.dynamitedata.ddfWelcome.messageActions.windowHideInstant();
			com.dynamitedata.ddfUtil.openDynamiteDataURL("main");
			
		},
	
		onClickCloseButton: function() {
			
			com.dynamitedata.ddfWelcome.messageActions.windowHideInstant();
			
		},
		
		onClickHelpBanner: function() {
			
			com.dynamitedata.ddfUtil.openDynamiteDataURL('help');
			com.dynamitedata.ddfWelcome.messageActions.windowHideInstant();
			
		},
		
		onStartup: function() {
			//if (!document.getElementById("ddStatusBar")) {
			//   return;
        	//}
			
			com.dynamitedata.ddfGlobals.dprint("Setting message window listeners...");
			try {
			document.getElementById("ddBoxLogoBgWelcome")
                .addEventListener("dblclick", messageEvents.onDblClickLogo, false);
            document.getElementById("detDdWelcomeBanner")
                .addEventListener("click", messageEvents.onClickCloseButton, false);
			document.getElementById("detDdBtnCloseWelcome")
                .addEventListener("click", messageEvents.onClickCloseButton, false);
            }
		  	catch (e) {}
			
		}
		
	}
	
	com.dynamitedata.ddfWelcome.messageActions = {
		
		hideHandle: null,
		
		// use this for the welcome message
		windowShowWelcome: function() {
			
			var sbHandle = document.getElementById("ddStatusBar");
			var messageDetailsHandle = document.getElementById("ddFrmMsgPanel");
			//document.getElementById("detDdWelcomeBanner").setAttribute("hidden", "false");
			document.getElementById("detDdWelcomeBanner").style.display = "-moz-box";
			
			messageDetailsHandle.style.opacity = 0;
			messageDetailsHandle.openPopup(sbHandle, "after_end", 0, 0, false, false);
			
			fade(0, 100, 1000, "ddFrmMsgPanel");
			
			//this.windowHideDelayed(3000);
			
		},
		
		windowShowInstant: function(message, showErrors) {
			
			var sbHandle = document.getElementById("ddStatusBar");
			var messageDetailsHandle = document.getElementById("ddFrmMsgPanel");
			messageDetailsHandle.setAttribute("noautohide", "false");
			messageDetailsHandle.style.opacity = 1;
			
			document.getElementById("rlMsgContentWrapper").style.display = "-moz-box";
			
			// get and prepare our template
			var messageBase = document.getElementById("lblMessageBase").cloneNode(true);
			var messageBox = document.getElementById("rlMsgContent");
			messageBase.hidden = false;
			while (messageBox.hasChildNodes()) {
				messageBox.removeChild(messageBox.firstChild);
			}
			
			if (message) {
				var newMessage = messageBase.cloneNode(true);
				newMessage.textContent = message;
				//newMessage.height = newMessage.scrollHeight;
				document.getElementById("rlMsgContent").appendChild(newMessage);
			}
			
			var curErrorMessage
			
			if (showErrors) {
			
				var curErrorMessage;
				
				for (var i in com.dynamitedata.ddfGlobals.stateTable) {
					
					if (com.dynamitedata.ddfGlobals.stateTable[i].statusNbr == -1) {
							
						curErrorMessage = messageBase.cloneNode(true);
						
						curErrorMessage.textContent = com.dynamitedata.ddfGlobals.stateTable[i].statusText;
						//curErrorMessage.height = curErrorMessage.scrollHeight;
						dprint("windowShowInstant: adding error message: " + curErrorMessage.textContent);
						document.getElementById("rlMsgContent").appendChild(curErrorMessage);
						
					}
					
				}
				
			}
			
			dprint("rlMsgContent has " + messageBox.hasChildNodes());
			
			// set the event listeners
			//var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
			//var current = gExtensionManager.getItemForID("ddfirefox@dynamitedata").version;
			var current = com.dynamitedata.ddfGlobals.globals.version;
			document.getElementById("lblMsgVersion").value = current;
			
			// show the box
			//document.getElementById("ddLstMessageRich").hidden = false;
			messageDetailsHandle.openPopup(sbHandle, "after_end", 0, 0, false, false);
			
			dprint("popup is " + messageDetailsHandle.state);
			
			if (typeof(hideHandle) != 'undefined') {
				window.clearTimeout(hideHandle);
			}
			
			dprint("Supposed to be showing this: " + message);
			
		},
		
		windowHideInstant: function() {
			var thePanel = document.getElementById("ddFrmMsgPanel");
			//document.getElementById("detDdWelcomeBanner").setAttribute("hidden", "true");
			document.getElementById("detDdWelcomeBanner").style.display = "none";
			//document.getElementById("ddLstMessageRich").setAttribute("hidden", "true");
			document.getElementById("rlMsgContentWrapper").style.display = "none";
			thePanel.hidePopup();
		},
		
		windowHideFadeout: function(msecs) {
			var thePanel = document.getElementById("ddFrmMsgPanel");
			fade(100, 0, msecs, "ddFrmMsgPanel");
			window.setTimeout(thePanel.hidePopup, msecs);
		},
		
		windowHideDelayed: function(fadeOutLength) {
			function executeHide() {
				com.dynamitedata.ddfWelcome.messageActions.windowHideFadeout(fadeOutLength);
			}
			
			hideHandle = window.setTimeout(executeHide, com.dynamitedata.ddfGlobals.MESSAGE_HIDE_DELAY_MSECS);
			
		}
		
	}
	
	function fade(startOpacityPercent, endOpacityPercent, msecs, id) {
			
			handle = document.getElementById(id);
			
			if (startOpacityPercent == endOpacityPercent) return; //BAD!
			
			///// the set up
			
			//determine direction
			var stepMult;
			if (startOpacityPercent < endOpacityPercent) {//fade in
				stepMult = 1;
			} else if (startOpacityPercent > endOpacityPercent) { //fade out
				stepMult = -1;
			}
			
			//var fadeInTimeMsecs = msecs;
			var fadeInOpacityStep = 100 / msecs; /* percent to fade in for each step */
			fadeInOpacityStep *= stepMult;
			
			//normalize numbers for firefox (opac range is 0.0 to 1.0)
			startOpacityPercent /= 100;
			endOpacityPercent /= 100;
			fadeInOpacityStep /= 100;
			
			com.dynamitedata.ddfGlobals.dprint("Fading " + id + ": masecs = " + msecs + " fadeInOpacityStep = " + fadeInOpacityStep);
			
			var date;
			var curTimePast = -1;
			var curFade = startOpacityPercent;
			var newStepAmt = 0;
			
			// start the fade in
			handle.style.opacity = curFade;
		
			function fade() {
				
				date = new Date();
				curTime = date.getTime();
				
				if (curTimePast == -1) curTimePast = curTime;
				
				newStepAmt = fadeInOpacityStep * Math.max(1, (curTime - curTimePast))
		
				curFade += newStepAmt;
				
				handle.style.opacity = curFade;
				
				if ((stepMult == 1 && handle.style.opacity >= 1) | (stepMult == -1 && handle.style.opacity <= 0)) {
					
					clearInterval(timer);
					
				}
				
				com.dynamitedata.ddfGlobals.dprint("opacity is " + handle.style.opacity + "(" + curFade + "); times are " + curTimePast + " - " + curTime + " = " + (curTime - curTimePast) + " * " + fadeInOpacityStep + " = " + (fadeInOpacityStep * (curTime - curTimePast)), 3);
				
				// set time for next tick
				curTimePast = curTime;
			}
			
			var hz = 30;
			var timer = setInterval(fade, (1000 / hz));
    
	}
	
	window.addEventListener("load", messageEvents.onStartup, false);

	
	

}

com.dynamitedata.ddfWelcome();