///// [ LICENSE ] //////////////////////////////////////////////////////////////
//
// (c) 2009 Dynamite Data / Tom Corelis
// 
// Unless explicitly stated otherwise, the programming code in this file is
// licensed to you pursuant the terms described in codelicense.txt.
//
////////////////////////////////////////////////////////////////////////////////

Components.utils.import("resource://ddfirefox/modules/globals.jsm");

var TEXT_INFORMATION = "Dynamite Deals aggregates price data for technology merchants around the internet.\n\nWhen you look at an item listing on a merchant that Dynamite Deals knows about, the Dynamite Deals Firefox add-on will search its database for other online merchants that offer the same item. The best deal will be shown to you in your statusbar, and the top three deals can be viewed with a single click.";
var TEXT_BGSCANNER_INFO = "In order to keep prices current, the Dynamite Deals Firefox add-on will periodically retreive a list of URLs to download and transmit back to Dynamite Deals. We call this tool our Price Agent.\n\nAll data received in this manner is immediately scanned for relevant pricing information and then discarded. The scanning process consumes very little resources and will not slow down your browser. However, if you'd prefer to turn off this process, simply un-check the box below.\n";
var TEXT_PREFTRANSMITDISABLE = "Enable Price Agent";
var TEXT_PREFTRUEMULTITHREADING = "Enable multithreading (experimental, may cause Firefox to crash.)";

var TEXT_COUNTRYOVERRIDE_DESC = "Dynamite Deals automatically presents you with merchants in your territory. If you would like to see merchants from another territory, you may override this behavior here.";
var TEXT_COUNTRYOVERRIDE_LISTBOX = "Show merchants from the following territory:";

var changed = false;

var optionsEvents = {
        onClickBtnOK: function() {
                
                // set preferences
                ddSetBoolPref("allowBackgroundScanning", document.getElementById("prefTransmitDisable").checked);
                //ddSetBoolPref("trueMultithreading", prefTrueMultithreading.checked);
                //ddSetStringPref("overrideCountry", lstInfoCountryOverride.selectedItem.getAttribute("value"));
                
                if (changed && 0) {
                
                        // confirm feedback changes
                        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);
                                
                        var cflags = (prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_YES) +
                                        (prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_IS_STRING) +
                                        (prompts.BUTTON_POS_2 * prompts.BUTTON_TITLE_NO);
                                        
                        var check = new Object();
                        var button = prompts.confirmEx(window,
                                  "Dynamite Deals",
                                  "It looks like you have unsubmitted feedback. Would you like to submit it before you close this window?",
                                  cflags,
                                  "Yes",
                                  "Continue editing",
                                  "No",
                                  null,
                                  check)
                        
                        switch (button) {
                                case 0: //user said Yes
                                        submitReport();
                                        break;
                                case 1: //user said continue editing
                                        break;
                                case 2: //user said no
                                        
                                        //close the window
                                        window.close();
                                        break;
                        }        
                } else {
                      //  window.close();
                }
                
                
        },
        
        onClickBtnCancel: function() {
                window.close();
        },
        
        onFeedbackChange: function() {
                changed = true;
        },
        
        onStartup: function() {
                
                this.chkDataGather = document.getElementById("prefTransmitDisable");
                this.prefTrueMultithreading = document.getElementById("prefTrueMultithreading");
                this.txtInfoMain = document.getElementById("txtInfoMain");
                this.txtInfoBgScan = document.getElementById("txtInfoBgScan");
                chkDataGather.checked = ddGetBoolPref("allowBackgroundScanning");
                dprint("chkDataGather = " + chkDataGather.checked);
                prefTrueMultithreading.checked = ddGetBoolPref("trueMultithreading");
                
                txtInfoMain.value = TEXT_INFORMATION;
                chkDataGather.label = TEXT_PREFTRANSMITDISABLE;
                txtInfoBgScan.value = TEXT_BGSCANNER_INFO;
                prefTrueMultithreading.label = TEXT_PREFTRUEMULTITHREADING;
                
                var txtInfoCountryOverride = document.getElementById("txtInfoCountryOverride");
                var lblInfoCountryOverride = document.getElementById("lblInfoCountryOverride");
                this.lstInfoCountryOverride = document.getElementById("lstInfoCountryOverride");
                var lstInfoCountryOverridePopup = document.getElementById("lstInfoCountryOverridePopup");
                
                
                txtInfoCountryOverride.value = TEXT_COUNTRYOVERRIDE_DESC;
                lblInfoCountryOverride.value = TEXT_COUNTRYOVERRIDE_LISTBOX;
                
                //// add countries from override list
                function createMenuItem(aLabel, aValue) {
                        
                        const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
                        var item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
                        item.setAttribute("label", aLabel);
                        item.setAttribute("value", aValue);
                        return item;
                
                }
                
                // get country list
                var overrideSelected = ddGetStringPref("overrideCountry");
                
                // if value is outside of list then someone's manually altered the pref
                var createOther = (LIST_COUNTRIES_OVERRIDES[overrideSelected.toLowerCase()] == null);
                dprint("currently selected override is " + overrideSelected + ", createOther is " + createOther);
                dprint(LIST_COUNTRIES_OVERRIDES[overrideSelected.toLowerCase()], 3);// populate menupopup
                
                // populate menupopup and select current pref
                function selectIfSelected(country, item) {
                        
                        dprint("checking " + country.toLowerCase() + " to " + overrideSelected.toLowerCase(), 2);
                        
                        if (country.toLowerCase() == overrideSelected.toLowerCase()) {
                                dprint("selecting...", 3);
                                lstInfoCountryOverride.selectedItem = item;
                        }
                }
                
                for (var country in LIST_COUNTRIES_OVERRIDES) {
                        
						var countryTemp;
                        if (country.toLowerCase() != "auto") {
                                countryTemp = " (" + country + ")";
                        } else {
                                countryTemp = "";
                        }
                        
                        var item = lstInfoCountryOverride.appendItem(LIST_COUNTRIES_OVERRIDES[country] + countryTemp.toUpperCase(),country);
                        selectIfSelected(country, item);
                }
                
                if (createOther) {
                        
                        country = overrideSelected;
                        item = lstInfoCountryOverride.appendItem("Unknown (" + overrideSelected.toUpperCase() + ")", overrideSelected.toLowerCase());
                        selectIfSelected(country, item);
                        
                }
                
                //document.getElementById("prefTransmitDisable").addEventListener("change", optionsEvents.onClickBtnOK, false);
                
                //txtInfoMain.rows = txtInfoMain.getRowCount();
                //txtInfoBgScan.rows = txtInfoBgScan.getRowCount();
                
                //window.setTimeout(function(){window.moveBy(0, -300); window.sizeToContent();}, 100);
                
        }
}

function gotoURL(urlTableEntry) {
        
        //document.commandDispatcher.focusedWindow.open(urlTable[urlTableEntry]);
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
        var brow = wm.getMostRecentWindow("navigator:browser").getBrowser();
        brow.selectedTab = brow.addTab(urlTable[urlTableEntry]);
        window.close();
        
}

window.addEventListener("load", optionsEvents.onStartup, false);