///// [ LICENSE ] //////////////////////////////////////////////////////////////
//
// (c) 2009 Dynamite Data / Tom Corelis
// 
// Unless explicitly stated otherwise, the programming code in this file is
// licensed to you pursuant the terms described in codelicense.txt.
//
////////////////////////////////////////////////////////////////////////////////

Components.utils.import("resource://ddfirefox/modules/globals.jsm");

var reporterEvents = {
	
	onStartup: function() {
			
		document.getElementById("frmOptionsVbox").addEventListener("click", closeAllTooltips, false);	
				
		
		if (window.arguments) {
			if (window.arguments[0]) document.getElementById("grpProblemType").selectedIndex = window.arguments[0];
			if (window.arguments[1]) {
				document.getElementById("txtURL").value = window.arguments[1];
				document.getElementById("boxURL").setAttribute("tooltip", "boxURLTooltip");
				var imgQuestionURL = document.getElementById("imgQuestionURL");
				imgQuestionURL.setAttribute("style", "display: -moz-box;");
				
				imgQuestionURL.addEventListener("click", function(ev){
					ev.stopPropagation();
					document.getElementById("boxURLTooltip").openPopup(imgQuestionURL, "after_pointer");
				}, true);
			}
		}
		
		document.getElementById("boxEmail").setAttribute("tooltip", "boxEmailTooltip");
		document.getElementById("imgQuestionEmail").addEventListener("click", function(ev){
			ev.stopPropagation();
			document.getElementById("boxEmailTooltip").openPopup(document.getElementById("imgQuestionEmail"), "after_pointer");
			}, true);
		
		
	},
	
	onPreviewReport: function(event) {
		
		var sel = event.originalTarget.selectedIndex;
		
		if (sel == 1) {

			var txtBuffer = generateXMLreport(true);
			document.getElementById("txtPreview").value = txtBuffer;
			
		}
		
	},
	
	onClickSubmit: function() {
		submitReport();
	},
	
	onClickCancel: function() {
		window.close();
	},
	
}

function closeAllTooltips(e) {
	
	var tips = document.getElementById("frmOptions").getElementsByTagName("tooltip");
	
	for each (var tip in tips) {
		tip.hidePopup();
	}
	
}

function generateReportObject() {
	// params
	var debugLogNumCharsToInclude = 5000;
	
	// get current version

	var reportObject = new Object();
	
	// NOTE: these log variables are standard across multiple Dynamite Data products
	// do not change these variable names without approval!
	
	reportObject.ddFirefoxVersion = globals.version;
	reportObject.requestType = document.getElementById("grpProblemType").selectedItem.id;
	reportObject.requestDescription = document.getElementById("txtDescription").value;
	reportObject.requestRelevantURL = document.getElementById("txtURL").value;
	reportObject.userName = document.getElementById("txtName").value;
	reportObject.userEmail = document.getElementById("txtEmail").value;
	reportObject.src = "ddfirefox";
	
	var optDebug = document.getElementById("optDbgYes");
	reportObject.debugLogIncluded = optDebug.selected;
	
	if (optDebug.selected) {
		reportObject.debugLogData = bufPeek(debugLogNumCharsToInclude);
	}
	
	return reportObject;
	
}

//function generateXMLreport(pretty) {
//	
//	// get current version
//	var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
//    var current = gExtensionManager.getItemForID("ddfirefox@dynamitedata").version;
//	
//	var xmlrpt = document.implementation.createDocument("", "", null);
//	
//	var report = document.createElement("report");
//	{
//		var basics = xmlrpt.createElement("basics");
//		basics.setAttribute("type", document.getElementById("grpProblemType").selectedItem.id)
//		basics.setAttribute("ddFversion", current);
//		
//		{
//			var url = xmlrpt.createElement("userURL");
//			var urlbuf = xmlrpt.createCDATASection(document.getElementById("txtURL").value)
//			
//			var description = xmlrpt.createElement("userDesc");
//			var descriptionbuf = xmlrpt.createCDATASection(document.getElementById("txtDescription").value);
//			
//			var email = xmlrpt.createElement("userEmail");
//			var emailbuf = xmlrpt.createCDATASection(document.getElementById("txtEmail").value);
//			
//			description.appendChild(descriptionbuf);
//			url.appendChild(urlbuf)
//			email.appendChild(emailbuf);
//			
//			basics.appendChild(url);
//			basics.appendChild(description);
//			basics.appendChild(email);
//		}
//		
//		var details = xmlrpt.createElement("details");
//		
//		var optDebug = document.getElementById("optDbgYes");
//		details.setAttribute("allowed", optDebug.selected);
//		
//		{	
//			if (optDebug.selected) {
//				
//				var debugLog = xmlrpt.createElement("debugLog");
//				
//				var debugLogBuf = xmlrpt.createCDATASection(bufPeek(5000));
//				
//				debugLog.appendChild(debugLogBuf);
//				details.appendChild(debugLog);
//			
//			}
//		
//		}
//		
//		report.appendChild(basics);
//		report.appendChild(details);
//		
//	}
//	
//	xmlrpt.appendChild(report);
//	
//	var serializer = new XMLSerializer();
//	if (pretty) {
//		return XML(serializer.serializeToString(xmlrpt)).toXMLString();	
//	} else {
//		return serializer.serializeToString(xmlrpt);
//	}
//	
//	
//}

function generatePOSTReport() {
	
	var Ci = Components.interfaces;
	var Cc = Components.classes;
	
	var reportObject = generateReportObject();
	
	//var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	//return nativeJSON.encode(reportObject);
	
	return dumper(reportObject);
	
}

function submitReport(clickType) {

			// pseudo-overloading
			if (!clickType) clickType = "submit";
	
			/* if (document.getElementById("txtDescription").value == "") {
				alert("Please enter a description.");
				return;
			} */
	
			document.getElementById("lblSubmitting").value = "Submitting, please wait...";
			document.getElementById("btnSubmit").disabled = true;
						
			// send the report
			var req = new XMLHttpRequest();
			dprint("User submitting contact request...");
			
			var messageContents = "";
			var reportObject = generateReportObject();
			var value = "";
			
			for (var item in reportObject) {
				
				value = "" + reportObject[item]; //so non-strings dont crash the whole thing
				/*value = supplant(value, {
					"=": '%3D',
					"&": '\%26'
				})*/
				value = escape(value);
				
				dprint("submitReport: r[" + item + "] = " + value, 2);
				
				messageContents += item + "=" + value + "&";
				
			}
			
			
			//var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
			req.open('POST', urlTable["report a problem"], false);
			req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			try {
				
				req.send(messageContents);
				
				// 
				dprint("Contact request server replied: " + req.responseText);
				var responseOKString = "SUCCESS";
				//var responseOKString = "la la la la";
			
				//dprint(req.responseText);
				
				if ((req.status == 200) && (req.responseText.search(responseOKString) != -1)){
					
						alert("Your message has been received. Thank you!");
						dprint("Contact request submitted successfully.");
						window.close();
					
				} else {
					
					var errorMessage;
					
					if (req.status != 200) {
						errorMessage = "Dynamite Data could not be contacted to send your message. Please try again later.\n\nDetails: Server returned response code " + req.status;
						dprint("Contact request submit failed. wget returned " + req.status);
					} else {
						errorMessage = "A server error occurred and your message could not be received. Please try again later.";
						dprint("Contact request submit failed. wget returned " + req.status + " but the server did not confirm success.");
					}
				
				}
					
			} catch(ex) {
				
				errorMessage = "The feedback request crashed for an unknown reason. Please copy the following information and send it to us at http://www.dynamitedata.com/contactus/\n\nException data:" + ex;
				
			} finally {
				
				document.getElementById("lblSubmitting").value = "";
				document.getElementById("btnSubmit").disabled = false;
				if (errorMessage) alert(errorMessage);
				
			}

}

function fillInValues(optType, url) {
	document.getElementById("grpProblemType").selectedItem = optType;
	if (url) document.getElementById("txtURL").value = url;
	
}

function scrub(input) {
	
}

window.addEventListener("load", reporterEvents.onStartup, false);