///// [ LICENSE ] //////////////////////////////////////////////////////////////
//
// (c) 2009 Dynamite Data / Tom Corelis
// 
// Unless explicitly stated otherwise, the programming code in this file is
// licensed to you pursuant the terms described in codelicense.txt.
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Respect the global namespace!
//
// Normal code is embedded in our module object.
////////////////////////////////////////////////////////////////////////////////
//Components.utils.import("resource://ddfirefox/modules/namespace-fix.jsm");
if(!com) var com = new Object();
if(!com.dynamitedata) com.dynamitedata = {};
if(!com.dynamitedata.ddfGlobals) com.dynamitedata.ddfGlobals = {};

Components.utils.import("resource://ddfirefox/modules/globals.jsm", com.dynamitedata.ddfGlobals);

////////////////////////////////////////////////////////////////////////////////
// stuff for XML
// https://developer.mozilla.org/en/Using_XPath
////////////////////////////////////////////////////////////////////////////////
// Evaluate an XPath expression aExpression against a given DOM node
// or Document object (aNode), returning the results as an array
// thanks wanderingstan at morethanwarm dot mail dot com for the
// initial work.
//function evaluateXPath(aExpr, aNode) {
//    var xpe = new XPathEvaluator();
//    var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement: aNode.ownerDocument.documentElement);
//    var result = xpe.evaluate(aExpr, aNode, nsResolver
//    /*null*/
//    , 0, null);
//    var found = [];
//    var res;
//    while (res = result.iterateNext()) {
//        found.push(res);
//        com.dynamitedata.ddfGlobals.dprint("evaluateXPath(): pushing res = " + res.toString(), 3);
//    }
//
//    return found;
//}

// Example usage:
// var els = docEvaluateArray('//a');
// alert(els[0].nodeName); // gives 'A' in HTML document with at least one link
com.dynamitedata.ddfUtil = function() {

    com.dynamitedata.ddfUtil.evaluateXPathToArray = function(expr, doc, context, resolver) {

        com.dynamitedata.ddfGlobals.dprint("evaluateXPathToArray called on " + doc, 2);
        doc = doc ? doc: document;
        resolver = resolver ? resolver: null;
        context = context ? context: doc;

        try {

            var result = doc.evaluate(expr, context, resolver, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
            var a = [];
            for (var i = 0; i < result.snapshotLength; i++) {
                a[i] = result.snapshotItem(i);
            }

            return a;

        } catch(e) {

            com.dynamitedata.ddfGlobals.dprint("evaluateXPathToArray(): CRASHED! " + e, 0);
            return null;

        }

    }

    // The following function allows one to pass an element and an XML document to 
    // find a unique string XPath expression leading back to that element. 
    com.dynamitedata.ddfUtil.getXPathForElement = function(el, xml) {
        var xpath = '';
        var pos, tempitem2;

        while (el !== xml.documentElement) {
            pos = 0;
            tempitem2 = el;
            while (tempitem2) {
                if (tempitem2.nodeType === 1 && tempitem2.nodeName === el.nodeName) { // If it is ELEMENT_NODE of the same name
                    pos += 1;
                }
                tempitem2 = tempitem2.previousSibling;
            }

            xpath = "*[name()='" + el.nodeName + "' and namespace-uri()='" + (el.namespaceURI === null ? '': el.namespaceURI) + "'][" + pos + ']' + '/' + xpath;

            el = el.parentNode;
        }
        xpath = '/*' + "[name()='" + xml.documentElement.nodeName + "' and namespace-uri()='" + (el.namespaceURI === null ? '': el.namespaceURI) + "']" + '/' + xpath;
        xpath = xpath.replace(/\/$/, '');
        return xpath;
    }

    ////////////////////////////////////////////////////////////////////////////////
    // misc stuff
    ////////////////////////////////////////////////////////////////////////////////

    // take a given URL and return the domain+TLD (no subdomain, no url)
    com.dynamitedata.ddfUtil.returnDomainTLD = function(url) {
        //try {
             var tmp = com.dynamitedata.ddfGlobals.globals.regexFindDomain.exec(url);
        //} catch(e) {
         //   alert(e);
        //}
        try {
            return tmp[1];
        } catch(e) {
            return null;
        }
    }

    ////////////////////////////////////////////////////////////////////////////////
    // Remedial Javascript functions -- useful features and such
    // http://javascript.crockford.com/remedial.html
    // No license issues per web page:
    //  "You can put these functions in your code library and copy them individually
    //  into your projects as you need them"
    ////////////////////////////////////////////////////////////////////////////////

    // The com.dynamitedata.ddfUtil.typeOf function above will only recognize arrays that are created in the
    // same context (or window or frame). JavaScript does not provide an infallible
    // mechanism for distinguishing arrays from objects, so if we want to recognize
    // arrays that are constructed in a different frame, then we need to do
    // something more complicated.
    com.dynamitedata.ddfUtil.typeOf = function(value) {
        var s = typeof value;
        if (s === 'object') {
            if (value) {
                if (typeof value.length === 'number' && !(value.propertyIsEnumerable('length')) && typeof value.splice === 'function') {
                    s = 'array';
                }
            } else {
                s = 'null';
            }
        }
        return s;
    }

    com.dynamitedata.ddfUtil.isEmpty = function(o) {
        var i, v;
        if (com.dynamitedata.ddfUtil.typeOf(o) === 'object') {
            for (i in o) {
                v = o[i];
                if (v !== undefined && com.dynamitedata.ddfUtil.typeOf(v) !== 'function') {
                    return false;
                }
            }
        }
        return true;
    }

    com.dynamitedata.ddfUtil.openDynamiteDataURL = function(urlTableEntry) {
        window.getBrowser().selectedTab = window.getBrowser().addTab(com.dynamitedata.ddfGlobals.urlTable[urlTableEntry]);
    }
}

//String.prototype.ddfEntityify = function() {
//    return this.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
//};
//
//String.prototype.ddfQuote = function() {
//    var c, i, l = this.length,
//    o = '"';
//    for (i = 0; i < l; i += 1) {
//        c = this.charAt(i);
//        if (c >= ' ') {
//            if (c === '\\' || c === '"') {
//                o += '\\';
//            }
//            o += c;
//        } else {
//            switch (c) {
//            case '\b':
//                o += '\\b';
//                break;
//            case '\f':
//                o += '\\f';
//                break;
//            case '\n':
//                o += '\\n';
//                break;
//            case '\r':
//                o += '\\r';
//                break;
//            case '\t':
//                o += '\\t';
//                break;
//            default:
//                c = c.charCodeAt();
//                o += '\\u00' + Math.floor(c / 16).toString(16) + (c % 16).toString(16);
//            }
//        }
//    }
//    return o + '"';
//};
//
//String.prototype.ddfTrim = function() {
//    return this.replace(/^\s+|\s+$/g, "");
//};

com.dynamitedata.ddfUtil();